unit uPluginContactos;

interface

uses
  uModuleController, uInterfaces, uHostManager, Menus, Classes, ActnList,
  ImgList, Controls, PngImageList;

type
  IMCContactos = interface(IInterface)
    ['{BAEDC5D8-2FE8-4907-8027-C60861829BA9}']

  end;
  
  TPluginContactos = class(TModuleController, IMCContactos)
    actClientes: TAction;
    actProveedores: TAction;
    Compras1: TMenuItem;
    ExtraImages: TPngImageList;
    LargeImages: TPngImageList;
    MainMenu: TMainMenu;
    ModuleActionList: TActionList;
    Proveedores1: TMenuItem;
    Resumen1: TMenuItem;
    SmallImages: TPngImageList;
    Ventas1: TMenuItem;
    actEmpleados: TAction;
    Vendedores1: TMenuItem;
    actGruposCliente: TAction;
    actGruposProveedor: TAction;
    actGruposEmpleado: TAction;
    Categoriasdeempleado1: TMenuItem;
    Gruposdeproveedor1: TMenuItem;
    Da1: TMenuItem;
    Empresa1: TMenuItem;
    procedure actClientesExecute(Sender: TObject);
    procedure actProveedoresExecute(Sender: TObject);
    procedure actEmpleadosExecute(Sender: TObject);
    procedure actGruposClienteExecute(Sender: TObject);
    procedure actGruposProveedorExecute(Sender: TObject);
    procedure actGruposEmpleadoExecute(Sender: TObject);
    procedure actEmpleadosUpdate(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

implementation

{$R *.dfm}

uses
  Forms, Dialogs, uGUIBase, uCustomEditor, SysUtils, uContactosController,
  uClientesController, uProveedoresController, uEmpleadosController,
  uGruposClienteController, uBizGruposCliente, uGruposProveedorController,
  uBizGruposProveedor, uGruposEmpleadoController, uBizGruposEmpleado,
  uContactosViewRegister, uBizContactos, uFactuGES_App;

function GetModule : TModuleController;
begin
  Result := TPluginContactos.Create(NIL);
end;

exports
  GetModule name GET_MODULE_FUNC;

{
******************************* TModuleContactos *******************************
}
procedure TPluginContactos.actClientesExecute(Sender: TObject);
var
  AClientesController : IClientesController;
  AClientes : IBizCliente;
begin
  try
  AClientesController := TClientesController.Create;
  AClientes := (AClientesController.BuscarTodos as IBizCliente);
  AClientesController.VerTodos(AClientes);
  finally
    AClientes := Nil;
    AClientesController := Nil; 
  end;
end;

procedure TPluginContactos.actGruposClienteExecute(Sender: TObject);
var
  AGruposClienteController : IGruposClienteController;
  AGruposCliente : IBizGrupoCliente;
begin
  AGruposClienteController := TGruposClienteController.Create;
  AGruposCliente := (AGruposClienteController.BuscarTodos as IBizGrupoCliente);
  AGruposClienteController.VerTodos(AGruposCliente);
end;

procedure TPluginContactos.actGruposEmpleadoExecute(Sender: TObject);
var
  AGruposEmpleadoController : IGruposEmpleadoController;
  AGruposEmpleado : IBizGrupoEmpleado;
begin
  AGruposEmpleadoController := TGruposEmpleadoController.Create;
  AGruposEmpleado := (AGruposEmpleadoController.BuscarTodos as IBizGrupoEmpleado);
  AGruposEmpleadoController.VerTodos(AGruposEmpleado);
end;

procedure TPluginContactos.actGruposProveedorExecute(Sender: TObject);
var
  AGruposProveedorController : IGruposProveedorController;
  AGruposProveedor : IBizGrupoProveedor;
begin
  AGruposProveedorController := TGruposProveedorController.Create;
  AGruposProveedor := (AGruposProveedorController.BuscarTodos as IBizGrupoProveedor);
  AGruposProveedorController.VerTodos(AGruposProveedor);
end;

procedure TPluginContactos.actProveedoresExecute(Sender: TObject);
var
  AProveedoresController : IProveedoresController;
  AProveedores : IBizProveedor;
begin
  AProveedoresController := TProveedoresController.Create;
  AProveedores := (AProveedoresController.BuscarTodos as IBizProveedor);
  AProveedoresController.VerTodos(AProveedores);
end;

procedure TPluginContactos.actEmpleadosExecute(Sender: TObject);
var
  AEmpleadosController : IEmpleadosController;
  AEmpleados : IBizEmpleado;
begin
  AEmpleadosController := TEmpleadosController.Create;
  AEmpleados := (AEmpleadosController.BuscarTodos as IBizEmpleado);
  AEmpleadosController.VerTodos(AEmpleados);
end;

procedure TPluginContactos.actEmpleadosUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := Assigned(AppFactuGES.EmpresaActiva);
end;

constructor TPluginContactos.Create(AOwner: TComponent);
begin
  inherited;
  uContactosViewRegister.RegisterViews;
end;

destructor TPluginContactos.Destroy;
begin
  uContactosViewRegister.UnregisterViews;
  inherited;
end;

initialization
  uHostManager.RegisterModuleClass(TPluginContactos);

finalization
  uHostManager.UnRegisterModuleClass(TPluginContactos);

end.
